# OroApiBundle Documentation

 - [CLI Commands](./commands.md)
 - [Configure Stateless Security Firewalls](./security.md)
 - [Configuration Reference](./configuration.md)
   - [**exclude** option](./configuration.md#exclude-option)
   - [**entity_aliases** configuration section](./configuration.md#entity_aliases-configuration-section)
   - [**entities** configuration section](./configuration.md#entities-configuration-section)
   - [**fields** configuration section](./configuration.md#fields-configuration-section)
   - [**filters** configuration section](./configuration.md#filters-configuration-section)
   - [**sorters** configuration section](./configuration.md#sorters-configuration-section)
   - [**actions** configuration section](./configuration.md#actions-configuration-section)
   - [**status_codes** configuration section](./configuration.md#action-status_codes-configuration-section)
   - [**subresources** configuration section](./configuration.md#subresources-configuration-section)
   - [**relations** configuration section](./configuration.md#relations-configuration-section)
 - [Configuration Extras](./configuration_extra.md)
 - [Configuration Extensions](./configuration_extensions.md)
   - [Creating configuration extension](./configuration_extensions.md#creating-configuration-extension)
   - [Add options to existing configuration section](./configuration_extensions.md#add-options-to-existing-configuration-section)
   - [Add new configuration section](./configuration_extensions.md#add-new-configuration-section)
 - [Forms and Validators Configuration](./forms.md)
 - [Documenting API Resources](./documentation.md)
   - [Overview](./documentation.md#overview)
   - [Documentation File Format](./documentation.md#documentation-file-format)
 - [Actions](./actions.md)
   - Public actions
     - [**get** action](./actions.md#get-action)
     - [**get_list** action](./actions.md#get_list-action)
     - [**delete** action](./actions.md#delete-action)
     - [**delete_list** action](./actions.md#delete_list-action)
     - [**create** action](./actions.md#create-action)
     - [**update** action](./actions.md#update-action)
     - [**get_subresource** action](./actions.md#get_subresource-action)
     - [**update_subresource** action](./actions.md#update_subresource-action)
     - [**add_subresource** action](./actions.md#add_subresource-action)
     - [**delete_subresource** action](./actions.md#delete_subresource-action)
     - [**get_relationship** action](./actions.md#get_relationship-action)
     - [**update_relationship** action](./actions.md#update_relationship-action)
     - [**add_relationship** action](./actions.md#add_relationship-action)
     - [**delete_relationship** action](./actions.md#delete_relationship-action)
   - Auxiliary actions
     - [**customize_loaded_data** action](./actions.md#customize_loaded_data-action)
     - [**customize_form_data** action](./actions.md#customize_form_data-action)
     - [**get_config** action](./actions.md#get_config-action)
     - [**get_relation_config** action](./actions.md#get_relation_config-action)
     - [**get_metadata** action](./actions.md#get_metadata-action)
     - [**normalize_value** action](./actions.md#normalize_value-action)
     - [**collect_resources** action](./actions.md#collect_resources-action)
     - [**collect_subresources** action](./actions.md#collect_subresources-action)
     - [**not_allowed** action](./actions.md#not_allowed-action)
   - [**Context** class](./actions.md#context-class)
   - [**SubresourceContext** class](./actions.md#subresourcecontext-class)
   - [Creating new action](./actions.md#creating-new-action)
 - [The Request Type](./request_type.md)
 - [Processors](./processors.md)
   - [Creating a processor](./processors.md#creating-a-processor)
   - [Processor conditions](./processors.md#processor-conditions)
   - [Examples of processor conditions](./processors.md#examples-of-processor-conditions)
   - [Error handling](./processors.md#error-handling)
 - [**X-Include** header](./headers.md)
 - [How To](./how_to.md)
   - [Turn on API for entity](./how_to.md#overview)
   - [Turn on API for entity disabled in "Resources/config/oro/entity.yml"](./how_to.md#turn-on-api-for-entity-disabled-in-resourcesconfigoroentityyml)
   - [Enable Advanced Operators for String Filter](./how_to.md#enable-advanced-operators-for-string-filter)
   - [Enable Case-insensitive String Filter](./how_to.md#enable-case-insensitive-string-filter)
   - [Change ACL resource for action](./how_to.md#change-acl-resource-for-action)
   - [Disable access checks for action](./how_to.md#disable-access-checks-for-action)
   - [Disable entity action](./how_to.md#disable-entity-action)
   - [Change delete handler for entity](./how_to.md#change-delete-handler-for-entity)
   - [Change the maximum number of entities that can be deleted by one request](./how_to.md#change-the-maximum-number-of-entities-that-can-be-deleted-by-one-request)
   - [Configure nested object](./how_to.md#configure-nested-object)
   - [Configure nested association](./how_to.md#configure-nested-association)
   - [Configure Extended Many-To-One Association](./how_to.md#configure-extended-many-to-one-association)
   - [Configure Extended Many-To-Many Association](./how_to.md#configure-extended-many-to-many-association)
   - [Configure Extended Multiple Many-To-One Association](./how_to.md#configure-extended-multiple-many-to-one-association)
   - [Add custom controller](./how_to.md#add-custom-controller)
   - [Add a Custom Route](./how_to.md#add-a-custom-route)
   - [Using a non-primary key to identify entity](./how_to.md#using-a-non-primary-key-to-identify-entity)
   - [Enable API for an Entity Without Identifier](./how_to.md#enable-api-for-an-entity-without-identifier)
   - [Enable Custom API](./how_to.md#enable-custom-api)
 - [Testing](./testing.md)
   - [Overview](./testing.md#overview)
   - [Load Fixtures](./testing.md#load-fixtures)
   - [Alice references](./testing.md#alice-references)
   - [Yaml templates](./testing.md#yaml-templates)
   - [Assert expectations](./testing.md#assert-expectations)
   - [Yaml templates for request body](./testing.md#yaml-templates-for-request-body)
   - [Process single reference](./testing.md#process-single-reference)
   - [Dump response into Yaml template](./testing.md#dump-response-into-yaml-template)
